unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, sqldb, sqlite3conn, FileUtil, Forms, Controls,
  Graphics, Dialogs, Buttons, DBGrids, DbCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public
    procedure AddData;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  IniFiles;

{ TForm1 }

procedure TForm1.AddData;
const
  FIRST_NAMES: array[0..5] of String = ('Tom', 'Mary', 'Bill', 'Susan', 'Joe', 'Anna');
  LAST_NAMES: array[0..4] of String = ('Miller', 'Jones', 'Dylan', 'Johnson', 'Murray');
  MAIL: array[0..3] of String = ('test.com', 'mail.com', 'fast.com', 'slow.com');
begin
  SQLQuery1.SQL.Clear;
  SQLQuery1.SQL.Add('INSERT INTO Clients (FirstName, LastName, Mail, Phone)');
  SQLQuery1.SQL.Add(Format(' VALUES("%0:s", "%1:s", "%0:s.%1:s@%2:s", "%3:s-%4:s %5:s")', [
    FIRST_NAMES[Random(Length(FIRST_NAMES))],
    LAST_NAMES[Random(Length(LAST_NAMES))],
    MAIL[Random(Length(MAIL))],
    FormatFloat('000', Random(1000)),
    FormatFloat('000', Random(1000)),
    FormatFloat('0000', Random(10000))
  ]));

  SQLQuery1.ExecSQL;
  SQLTransAction1.Commit;

  SQLQuery1.SQL.Text := 'SELECT * FROM Clients';
  SQLQuery1.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  AddData;
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  FILL_SPACE = true;
var
  fn: String;
  i: Integer;
begin
  fn := Application.Location + 'data.db';
  if not FileExists(fn) then
  begin
    SQLite3Connection1.DatabaseName := 'data.db';
    SQLite3Connection1.Connected := True;
    SQLTransaction1.DataBase := SQLite3Connection1;
    SQLQuery1.DataBase := SQLite3Connection1;
    SQLTransaction1.Active := True;

    SQLite3Connection1.ExecuteDirect('CREATE TABLE Clients(ID INTEGER PRIMARY KEY, FirstName STRING, LastName STRING, Mail VARCHAR, Phone VARCHAR[20])');
    SQLTransaction1.Commit;

    SQLQuery1.SQL.Text:='SELECT * FROM Clients';
    SQLQuery1.Open;

    DataSource1.DataSet:=SQLQuery1;
    DBGrid1.DataSource:=DataSource1;

    Randomize;
    AddData;
    AddData;
    AddData;
  end
  else
  begin
    SQLite3Connection1.DatabaseName := 'data.db';
    SQLite3Connection1.Connected := true;
    SQLTransaction1.DataBase := SQLite3Connection1;
    SQLQuery1.DataBase := SQLite3Connection1;
    SQLTransaction1.Active := True;
    SQLQuery1.SQL.Text := 'SELECT * FROM Clients';
    SQLQuery1.Open;
    DataSource1.DataSet := SQLQuery1;
    DBGrid1.DataSource := DataSource1;
  end;

  DBGrid1.Columns.Clear;
  for i:=0 to SQLQuery1.FieldCount-1 do
    with DBGrid1.Columns.Add do begin
      FieldName := SQLQuery1.Fields[i].FieldName;
      Caption := SQLQuery1.Fields[i].FieldName;
      if FILL_SPACE then
        if i = 3 then SizePriority := 1 else SizePriority := 0;
    end;

  DBGrid1.Options := DBGrid1.Options + [dgAutoSizeColumns];
  if FILL_SPACE then
    DBGrid1.AutoFillColumns := true
  else
    DBGrid1.AutoAdjustColumns;
end;

end.

